import jax.numpy as np
import numpyro.distributions as npdist
import numpy as onp
import jax

def load_model():
	def log_prob(z_g, z_l_sub, params, indices, factor=True):
		def log_prob_local_ind(z_l, i):
			mean = mean_l[i, :]
			scale = scale_l[i, :]
			dist = npdist.Normal(loc = mean, scale = scale)
			return dist.log_prob(z_l).sum()
		
		dist_g = npdist.Normal(loc = mean_g, scale = scale_g)
		lp = dist_g.log_prob(z_g).sum()

		f = jax.lax.cond(factor, lambda : num_l * 1. / indices.shape[0], lambda : 1.)

		lp_local = jax.vmap(log_prob_local_ind, in_axes = (0, 0))(z_l_sub, indices)
		lp = lp + lp_local.sum() * f
		return lp

	dim_g = 1
	dim_l = 2
	num_l = 20

	mean_g = 2.
	scale_g = 3.
	mean_l = np.zeros((num_l, dim_l)) + np.arange(num_l)[:, None] / (num_l / 2)
	scale_l = np.ones((num_l, dim_l))
	return log_prob, dim_g, dim_l, num_l, np.array(0.)



