import jax.numpy as np
from numpyro.distributions.transforms import AffineTransform


def apply_transform(inputs, mean, scale, lam):
	transform = AffineTransform(
		loc = mean - np.power(scale, 1. - lam) * lam * mean, 
		scale = np.power(scale, 1. - lam)
	)
	outputs = transform(inputs)
	log_det_jac = transform.log_abs_det_jacobian(inputs, outputs)
	return outputs, log_det_jac.sum()