import jax.numpy as np
import numpyro.distributions as npdist
import numpy as onp
import jax

def load_model():
	def log_prob_local_ind(z_g, z_l, params, i):
		dist = npdist.StudentT(df = 3, loc = 0., scale = 1.)
		return dist.log_prob(z_l).sum()
	
	def log_prob_global(z_g, params):
		dist = npdist.StudentT(df = 3, loc = 0., scale = 1.)
		return dist.log_prob(z_g).sum()

	def log_prob(z_g, z_l_sub, params, indices, factor=True):
		def log_prob_local_ind(z_l, i):
			dist = npdist.StudentT(df = 3, loc = 0., scale = 1.)
			return dist.log_prob(z_l).sum()
		
		dist_g = npdist.StudentT(df = 3, loc = 0., scale = 1.)
		lp = dist_g.log_prob(z_g).sum()

		f = jax.lax.cond(factor, lambda : num_l * 1. / indices.shape[0], lambda : 1.)

		lp_local = jax.vmap(log_prob_local_ind, in_axes = (0, 0))(z_l_sub, indices)
		lp = lp + lp_local.sum() * f
		return lp

	dim_g = 1
	dim_l = 2
	num_l = 20
	return log_prob, log_prob_global, log_prob_local_ind, dim_g, dim_l, num_l, np.array(0.)
