import vardist.diag_gauss as diag_g
import vardist.full_gauss as full_g
import vardist.diag_gauss_local as diag_l



def initialize_global(dim, vdmode):
	if vdmode == 1:
		return diag_g.initialize(dim)
	elif vdmode == 2:
		return full_g.initialize(dim)
	else:
		raise NotImplementedError("Global VD not implemented.")

def initialize_local(dim, num, vdmode):
	if vdmode == 1:
		return diag_l.initialize(dim, num)
	else:
		raise NotImplementedError("Local VD not implemented.")


# Next two, should check if sample rep sample all or only local. I guess latter more efficient?
# Should be careful with log_prob_local

def sample_rep_global(rng_key, vdmode, vdparams):
	if vdmode == 1:
		return diag_g.sample_rep(rng_key, vdparams)
	elif vdmode == 2:
		return full_g.sample_rep(rng_key, vdparams)
	raise NotImplementedError("Global VD sampling not implemented.")

def sample_rep_local(rng_key, vdmode, vdparams, indices):
	if vdmode == 1:
		return diag_l.sample_rep(rng_key, vdparams, indices)
	else:
		raise NotImplementedError("Local VD sampling not implemented.")


def log_prob_global(vdmode, vdparams, z):
	if vdmode == 1:
		return diag_g.log_prob(z, vdparams)
	elif vdmode == 2:
		return full_g.log_prob(z, vdparams)
	raise NotImplementedError("Log prob VD global not implemented.")

def log_prob_local(vdmode, vdparams, z_l_sub, indices, factor=True):
	if vdmode == 1:
		return diag_l.log_prob(z_l_sub, vdparams, indices, factor)
	raise NotImplementedError("Log prob VD local not implemented.")

def log_prob_local_ind(vdmode, vdparams, z_l, i):
	if vdmode == 1:
		return diag_l.log_prob_ind(z_l, vdparams, i)
	raise NotImplementedError("Log prob VD local not implemented.")








